package com.hai.pay.channel.huift.config;

import org.apache.commons.lang3.StringUtils;

import javax.xml.bind.annotation.adapters.HexBinaryAdapter;
import java.security.MessageDigest;
import java.util.Arrays;
import java.util.Map;
import java.util.Set;

/**
 * @className: HuiftConfig
 * @author: HuRui
 * @date: 2024/4/7
 **/
public class HuiftConfig {

    public final static String reqUrl = "https://linktest.huift.com.cn";
    public final static String shopcode = "50041b27-f985-dcb0-1cc0-f106b09bf1fe";
    public final static String signSecret = "DB4D8069A9AC6DDF9D75667EE5CF182A";

    /**
     * 参数排序
     * @param param
     * @return
     */
    public static String paramSort(final Map<String, Object> param, String key) {
        Set<String> keySet = param.keySet();
        String[] keyArray = keySet.toArray(new String[keySet.size()]);
        Arrays.sort(keyArray);
        StringBuilder sb = new StringBuilder();
        for (String k : keyArray) {
            if (StringUtils.isBlank(sb.toString())) {
                sb.append(k).append("=").append(param.get(k));
            } else {
                sb.append("&").append(k).append("=").append(param.get(k));
            }
        }
        sb.append(key);
        return sb.toString();
    }

    /**
     * MD5加密
     * @param data
     * @return
     * @throws Exception
     */
    public static String md5Encode(byte[] data) throws Exception {
        // 初始化MessageDigest
        MessageDigest md = MessageDigest.getInstance("MD5");
        // 执行摘要信息
        byte[] digest = md.digest(data);
        // 将摘要信息转换为32位的十六进制字符串
        return new String(new HexBinaryAdapter().marshal(digest));
    }

}
